#ifndef controlpropertiesproperties_h_included
#define controlpropertiesproperties_h_included
/***************************************************************************
 *                          Zanoza Modeler v2.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                   Copyright (c) 2002 Zanoza Software.                   *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg M.
 *--------------------------------------------------------------------------
 * @purpose:  ZModeler 2.x control properties
 *--------------------------------------------------------------------------
 * @histroy: 08.06.2004. Created
 */
#include <zmodeler.h>
#include <helpers/layout.h>
#include <services/IPropertiesSource.h>

//-----------------------------------------------------
//
// General properties
//
//-----------------------------------------------------
namespace core
{
  namespace tools
  {
    class CControlPointProperties : public services::IPropertiesSource
    {
    public:
      INTERFACE_DECLAREMAP(CControlPointProperties)

      CControlPointProperties();
      virtual ~CControlPointProperties();

    public:
      //-----------------------
      // IPropertiesSource
      //-----------------------
      virtual ZRESULT applyProperties(core::IProcParams* pParams, core::eLevel level, scene::tNodeSeq& seqNodes, services::IPropertiesService* pService);
      virtual ZRESULT queryProperties(core::IProcParams* pParams, core::eLevel level, scene::tNodeSeq& seqNodes, services::IPropertiesService* pService);
    private:
      //misc:
      long        m_nID;
      bool        m_bCompBits[8];//external bits (surface generation assignment)
      float       m_fUV;
      long        m_nDetail;
      bool        m_bAuto;
      long        m_nType;//cast to scene::eControlPoint
      ZStringSeq  m_seqBitsNames;
      ZStringSeq  m_seqTypeNames;
    };
  };//tools
};//core

#endif //controlpropertiesproperties_h_included

